diff --git a/README b/README
index 3105e19..0570a25 100644
--- a/README
+++ b/README
@@ -1,14 +1,17 @@
 
 
-                        Bywater Software Announces
+                              README file for
 
 
-               Bywater BASIC Interpreter/Shell, version 2.10
+               Bywater BASIC Interpreter/Shell, version 2.20
                ---------------------------------------------
 
                     Copyright (c) 1993, Ted A. Campbell
                   for bwBASIC version 2.10, 11 October 1993
 
+               Version 2.20 modifications by Jon B. Volkoff,
+                             25 November 1995
+
 
 
 DESCRIPTION:
@@ -29,40 +32,50 @@ DESCRIPTION:
    for information on which you should contact the author.
 
 
-IMPROVEMENTS OVER PREVIOUS VERSION (1.11):
+IMPROVEMENTS OVER PREVIOUS VERSION (2.10):
+
+   * Plugged numerous memory leaks, resolved memory overruns and allocation
+     difficulties.
+
+   * General cleanup and bug fixes, too many to list in detail here.
+     The major problem areas addressed were:
+
+      - RUN command with file name argument
+      - nested and cascaded FOR-NEXT loops
+      - PRINT USING
+      - EOF, LOF functions
+      - string concatenation
+      - operator hierarchy
+      - multi-level expression evaluation
+      - hex constant interpretation
+      - hex and octal constants in INPUT and DATA statements
 
-   * now compilable on "stock" (older K&R specification) C compilers; 
+   * Added a CLOSE all files feature (when no argument supplied).
 
-   * implements ANSI-BASIC-style structured programming, with
-     called subroutines, multi-line functions, multi-line IF-THEN
-     ELSE statements, SELECT CASE statements, etc.;
+   * Added a unary minus sign operator.
 
-   * new enhancements to the interactive environment, such as DO NUM
-     and DO UNNUM to number or unnumber all program lines;
+   * Added a MID$ command to complement the MID$ function.
 
-   * addition of some hardware-specific commands such as CLS, LOCATE,
-     and INKEY$ (at present for IBM PC and compatibles, using the
-     Microsoft QuickC compiler), opening the way for more hardware-
-     specific commands and functions in the future; 
+   * Added a RENUM facility in a standalone program.
 
-   * general improvements to reliability and portability, including
-     more extensive testing than previous versions; 
+   * Added checking in configure for unistd.h (important on Sun systems).
 
 
 OBTAINING THE SOURCE CODE:
 
-   The source code for bwBASIC 2.10 will be posted to network news
-   groups and is available immediately by anonymous ftp. To obtain
-   the source code, ftp to site ftp.eng.umd.edu, cd to pub/basic and
-   get the file bwbasic-2.10.tar.gz.
+   The source code for bwBASIC 2.20 is available immediately by
+   anonymous ftp. To obtain the source code, ftp to site ftp.netcom.com,
+   cd to pub/rh/rhn and get the file bwbasic-2.20.uu. Or you may receive
+   a copy by e-mail by writing to Jon Volkoff at eidetics@cerf.net.
 
 
 COMMUNICATIONS:
 
-   email:  tcamp@delphi.com
+   email:  tcamp@delphi.com  (for Ted Campbell)
+           eidetics@cerf.net (for Jon Volkoff)
 
 
-A LIST OF BASIC COMMANDS AND FUNCTIONS IMPLEMENTED in bwBASIC 2.10:
+A LIST OF BASIC COMMANDS AND FUNCTIONS IMPLEMENTED in bwBASIC 2.20:
 
    Be aware that many of these commands and functions will not be
    available unless you have set certain flags in the header files.
@@ -96,7 +109,7 @@ A LIST OF BASIC COMMANDS AND FUNCTIONS IMPLEMENTED in bwBASIC 2.10:
    DIM variable(elements...)[variable(elements...)]...
    DO NUM|UNNUM
    DO [WHILE expression]
-   EDIT         (* depends on variable BWB.EDITOR$)
+   EDIT		(* depends on variable BWB.EDITOR$)
    ELSE
    ELSEIF
    END FUNCTION | IF | SELECT | SUB
@@ -110,7 +123,7 @@ A LIST OF BASIC COMMANDS AND FUNCTIONS IMPLEMENTED in bwBASIC 2.10:
    EXIT FOR|DO
    EXP( number )
    FIELD [#] device-number, number AS string-variable [, number AS string-variable...]
-   FILES filespec$      (* depends on variable BWB.FILES$)
+   FILES filespec$	(* depends on variable BWB.FILES$)
    FOR counter = start TO finish [STEP increment]
    FUNCTION function-definition
    GET [#] device-number [, record-number]
@@ -156,6 +169,7 @@ A LIST OF BASIC COMMANDS AND FUNCTIONS IMPLEMENTED in bwBASIC 2.10:
    RANDOMIZE number
    READ variable[, variable]...
    REM string
+   RENUM
    RESTORE line
    RETURN
    RIGHT$( string$, number-of-spaces )
diff --git a/bwb_cmd.c b/bwb_cmd.c
index a18445d..797fb61 100644
--- a/bwb_cmd.c
+++ b/bwb_cmd.c
@@ -46,6 +46,14 @@
 
 ***************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*                                                               */
+/* Those additionally marked with "DD" were at the suggestion of */
+/* Dale DePriest (daled@cadence.com).                            */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 #include <math.h>
 #include <ctype.h>
@@ -710,7 +718,8 @@ bwb_on( l )
 
       /* get memory for line and buffer */
 
-      if ( ( oline = calloc( 1, sizeof( struct bwb_line ) ) ) == NULL )
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( oline = CALLOC( 1, sizeof( struct bwb_line ), "bwb_on") ) == NULL )
 	 {
 #if PROG_ERRORS
 	 bwb_error( "in bwb_on(): failed to find memory for oline" );
@@ -718,7 +727,8 @@ bwb_on( l )
 	 bwb_error( err_getmem );
 #endif
 	 }
-      if ( ( oline->buffer = calloc( 1, MAXSTRINGSIZE + 1 ) ) == NULL )
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( oline->buffer = CALLOC( 1, MAXSTRINGSIZE + 1, "bwb_on") ) == NULL )
 	 {
 #if PROG_ERRORS
 	 bwb_error( "in bwb_on(): failed to find memory for oline buffer" );
@@ -983,22 +993,27 @@ bwb_run( l )
          bwb_error( bwb_ebuf );
          }
       bwb_fload( input );		/* load program */
-      bwb_run( &CURTASK bwb_start );            /* and call bwb_run() recursively */
+
+      /* Next line removed by JBV (unnecessary recursion asks for trouble) */
+      /* bwb_run( &CURTASK bwb_start ); */         /* and call bwb_run() recursively */
+      current = &CURTASK bwb_start; /* JBV */
       }
 
    /* else if it is a line number, execute the program in memory
       at that line number */
 
-   else
-      {
+   /* Removed by JBV */
+   /* else
+      { */
 
-      if ( current == NULL )
-         {
+      /* Removed by JBV */
+      /* if ( current == NULL )
+         { */
 
-         if ( e != NULL )
-            {
+         /* Added expression type check and changed loop boundaries (JBV) */
+         if (( e != NULL ) && ( e->type != STRING ))
+         {
             go_lnumber = (int) exp_getnval( e );
-            }
 
 #if INTENSIVE_DEBUG
          sprintf( bwb_ebuf, "in bwb_run(): element detected <%s>, lnumber <%d>",
@@ -1015,6 +1030,8 @@ bwb_run( l )
             }
          }
 
+      /*    } */ /* Removed by JBV */
+
       if ( current == NULL )
          {
          sprintf( bwb_ebuf, err_lnnotfound, go_lnumber );
@@ -1037,7 +1054,7 @@ bwb_run( l )
       CURTASK exsc = 0;
       bwb_setexec( current, 0, EXEC_NORM );
 
-      }
+   /*    } */ /* Removed by JBV */
 
 #if INTENSIVE_DEBUG
    sprintf( bwb_ebuf, "in bwb_run(): function complete." );
@@ -1178,6 +1195,7 @@ bwb_xload( l )
 #endif
    {
    FILE *loadfile;
+   struct exp_ese *e; /* JBV */
 
    /* Get an argument for filename */
 
@@ -1188,13 +1206,31 @@ bwb_xload( l )
       case '\n':
       case '\r':
       case ':':
+         bwb_error( err_nofn ); /* Added by JBV (bug found by DD) */
 
          return bwb_zline( l );
       default:
          break;
       }
 
-   bwb_const( l->buffer, CURTASK progfile, &( l->position ) );
+   /* Section added by JBV (bug found by DD) */
+   e = bwb_exp( l->buffer, FALSE, &( l->position ) );
+   if ( e->type != STRING )
+      {
+#if PROG_ERRORS
+      sprintf( bwb_ebuf, "in bwb_xload(): Missing filespec" );
+      bwb_error( bwb_ebuf );
+#else
+      bwb_error( err_syntax );
+#endif
+
+      return bwb_zline( l );
+      }
+
+   /* This line removed by JBV (no longer required) */
+   /* bwb_const( l->buffer, CURTASK progfile, &( l->position ) ); */
+   str_btoc( CURTASK progfile, exp_getsval( e ) ); /* JBV */
+
    if ( ( loadfile = fopen( CURTASK progfile, "r" )) == NULL )
       {
       sprintf( bwb_ebuf, err_openfile, CURTASK progfile );
@@ -1214,7 +1250,7 @@ bwb_xload( l )
         FUNCTION:       bwb_save()
 
 	DESCRIPTION:    This C function implements the BASIC
-			LOAD command.
+			SAVE command.
 
    	SYNTAX:		SAVE file-name
 
@@ -1231,6 +1267,7 @@ bwb_save( l )
    {
    FILE *outfile;
    static char filename[ MAXARGSIZE ];
+   struct exp_ese *e; /* JBV */
 
 #if INTENSIVE_DEBUG
    sprintf( bwb_ebuf, "in bwb_save(): entered function." );
@@ -1253,7 +1290,24 @@ bwb_save( l )
          break;
       }
 
-   bwb_const( l->buffer, filename, &( l->position ) );
+   /* Section added by JBV (bug found by DD) */
+   e = bwb_exp( l->buffer, FALSE, &( l->position ) );
+   if ( e->type != STRING )
+      {
+#if PROG_ERRORS
+      sprintf( bwb_ebuf, "in bwb_save(): Missing filespec" );
+      bwb_error( bwb_ebuf );
+#else
+      bwb_error( err_syntax );
+#endif
+
+      return bwb_zline( l );
+      }
+
+   /* This line removed by JBV (no longer required) */
+   /* bwb_const( l->buffer, filename, &( l->position ) ); */
+   str_btoc( filename, exp_getsval( e ) ); /* JBV */
+
    if ( ( outfile = fopen( filename, "w" )) == NULL )
       {
       sprintf( bwb_ebuf, err_openfile, filename );
@@ -1476,7 +1530,7 @@ xl_line( file, l )
    if (( file == stdout ) || ( file == stderr ))
       {
 
-      if ( l->xnum == TRUE )
+      if ( l->xnum == (char) TRUE ) /* Better recast this one (JBV) */
 	 {
 	 sprintf( tbuf, "%7d: %s\n", l->number, l->buffer );
 	 }
@@ -1490,7 +1544,7 @@ xl_line( file, l )
    else
       {
 
-      if ( l->xnum == TRUE )
+      if ( l->xnum == (char) TRUE ) /* Better recast this one (JBV) */
 	 {
 	 fprintf( file, "%d %s\n", l->number, l->buffer );
 	 }
@@ -1556,7 +1610,8 @@ bwb_delete( l )
       {
       if ( current != l )
          {
-         if (( current->xnum == TRUE ) && ( current->number == s ))
+         /* Following line revised by JBV */
+         if (( current->xnum == (char) TRUE ) && ( current->number == s ))
             {
             f = TRUE;
             previous = p;
@@ -1589,7 +1644,8 @@ bwb_delete( l )
          {
          if ( current != l )
             {
-            if (( current->xnum == TRUE) &&  ( current->number == e ))
+            /* Following line revised by JBV */
+            if (( current->xnum == (char) TRUE) &&  ( current->number == e ))
                {
 #if INTENSIVE_DEBUG
 	       sprintf( bwb_ebuf, "in bwb_delete(): end line number is <%d>",
@@ -1989,7 +2045,9 @@ bwb_xnew( l )
       {
       if ( wait != TRUE )
          {
-         free( previous );
+         /* Revised to FREE pass-thru call by JBV */
+         FREE( previous, "bwb_xnew" );
+         previous = NULL; /* JBV */
          }
       wait = FALSE;
       previous = current;
@@ -2214,4 +2272,3 @@ bwb_zline( l )
    }
 
 
-
\ No newline at end of file
diff --git a/bwb_cnd.c b/bwb_cnd.c
index 4a16682..d2368ee 100644
--- a/bwb_cnd.c
+++ b/bwb_cnd.c
@@ -23,6 +23,14 @@
 
 ***************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*                                                               */
+/* Those additionally marked with "DD" were at the suggestion of */
+/* Dale DePriest (daled@cadence.com).                            */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 #include <math.h>
 #include <ctype.h>
@@ -180,7 +188,11 @@ bwb_if( l )
          }
       else
          {
-         bwb_setexec( endif_line, 0, CURTASK excs[ CURTASK exsc ].code );
+         /* Following line incorrect, replaced by next two (bug found by DD) */
+         /* bwb_setexec( endif_line, 0, CURTASK excs[ CURTASK exsc ].code ); */
+
+         bwb_incexec(); /* JBV */
+         bwb_setexec( endif_line, 0, EXEC_IFFALSE ); /* JBV */
          endif_line->position = 0;
          return endif_line;
          }
@@ -265,13 +277,14 @@ bwb_if( l )
       if ( els != FALSE )
          {
          l->position = els + strlen( CMD_ELSE ) + 1;
-         bwb_setexec( l, els, EXEC_NORM );
+         /* bwb_setexec( l, els, EXEC_NORM ); */ /* Nope (JBV) */
+         bwb_setexec( l, els, CURTASK excs[ CURTASK exsc ].code ); /* JBV */
 	 return l;
 	 }
       }
 
    /* if neither then nor else were found, advance to next line */
-   /* DO NOT advance to next segment (only if TRUE should we do that */
+   /* DO NOT advance to next segment (only if TRUE should we do that) */
 
    l->next->position = 0;
    return l->next;
@@ -437,7 +450,13 @@ bwb_else( l )
    /* If the code is EXEC_NORM, then this is a continuation of a single-
       line IF...THEN...ELSE... statement and we should return */
 
-   if ( CURTASK excs[ CURTASK exsc ].code == EXEC_NORM )
+   /*----------------------------------------------------------------------*/
+   /* Well, not really... better to check for EXEC_IFTRUE or EXEC_IFFALSE, */
+   /* and if not equal, then blow entirely out of current line (JBV)       */
+   /*----------------------------------------------------------------------*/
+
+   /* Section removed by JBV */
+   /* if ( CURTASK excs[ CURTASK exsc ].code == EXEC_NORM )
       {
 
 #if INTENSIVE_DEBUG
@@ -446,6 +465,20 @@ bwb_else( l )
 #endif
 
       return bwb_zline( l );
+      } */
+
+   /* Section added by JBV */
+   if (( CURTASK excs[ CURTASK exsc ].code != EXEC_IFTRUE ) &&
+   ( CURTASK excs[ CURTASK exsc ].code != EXEC_IFFALSE ))
+      {
+
+#if INTENSIVE_DEBUG
+      sprintf( bwb_ebuf, "in bwb_else(): no EXEC_IFTRUE or EXEC_IFFALSE" );
+      bwb_debug( bwb_ebuf );
+#endif
+
+      l->next->position = 0;
+      return l->next;
       }
 
    endif_line = find_endif( l, &else_line );
@@ -1751,6 +1784,14 @@ bwb_for( l )
    bwb_debug( bwb_ebuf );
 #endif
 
+   /*--------------------------------------------------------------*/
+   /* Make sure we are in the right FOR-NEXT level!                */
+   /* If we aren't (which could happen for legit reasons), fix the */
+   /* exec stack.                                                  */
+   /* JBV, 9/20/95                                                 */
+   /*--------------------------------------------------------------*/
+   if (v == CURTASK excs[ CURTASK exsc].local_variable) bwb_decexec();
+
    /* at this point one should find an equals sign ('=') */
 
    adv_ws( l->buffer, &( l->position ) );
@@ -1972,9 +2013,7 @@ bwb_next( l )
 #endif
    {
    char tbuf[ MAXSTRINGSIZE + 1 ];
-#if INTENSIVE_DEBUG
-   struct bwb_variable *v;
-#endif
+   struct bwb_variable *v; /* Relocated from INTENSIVE_DEBUG (JBV) */
 
 #if INTENSIVE_DEBUG
    sprintf( bwb_ebuf, "in bwb_next(): entered function, cmdnum <%d> exsc level <%d> code <%d>",
@@ -1997,13 +2036,19 @@ bwb_next( l )
 
    /* read the argument, if there is one */
 
+   /* Relocated from MULTISEG_LINES (JBV) */
+   exp_getvfname( &( l->buffer[ l->position ] ), tbuf );
+
+   if (strlen(tbuf) != 0)
+   {
+   /* Relocated from INTENSIVE_DEBUG (JBV) */
+   v = var_find( tbuf );
+
 #if MULTISEG_LINES                   /* not currently needed otherwise */
 
-   exp_getvfname( &( l->buffer[ l->position ] ), tbuf );
    l->position += strlen( tbuf );
 
 #if INTENSIVE_DEBUG
-   v = var_find( tbuf );
    sprintf( bwb_ebuf, "in bwb_next(): variable name detected <%s>.", v->name );
    bwb_debug( bwb_ebuf );
 #endif
@@ -2011,6 +2056,15 @@ bwb_next( l )
 
    /* decrement or increment the value */
 
+   /*--------------------------------------------------------------*/
+   /* Make sure we are in the right FOR-NEXT level!                */
+   /* If we aren't (which could happen for legit reasons), fix the */
+   /* exec stack.                                                  */
+   /* JBV, 9/20/95                                                 */
+   /*--------------------------------------------------------------*/
+   while (v != CURTASK excs[ CURTASK exsc].local_variable) bwb_decexec();
+   }
+
    var_setnval( CURTASK excs[ CURTASK exsc ].local_variable,
       var_getnval( CURTASK excs[ CURTASK exsc ].local_variable )
       + (bnumber) CURTASK excs[ CURTASK exsc ].for_step );
@@ -2077,12 +2131,14 @@ bwb_next( l )
       = CURTASK excs[ CURTASK exsc ].for_position;
    bwb_setexec( CURTASK excs[ CURTASK exsc ].for_line,
       CURTASK excs[ CURTASK exsc ].for_position, EXEC_FOR );
+
+   return CURTASK excs[ CURTASK exsc ].for_line; /* Added (JBV) */
 #else
    bwb_setexec( CURTASK excs[ CURTASK exsc - 1 ].line,
       CURTASK excs[ CURTASK exsc - 1 ].position, EXEC_FOR );
-#endif
 
-   return CURTASK excs[ CURTASK exsc - 1 ].line;
+   return CURTASK excs[ CURTASK exsc - 1 ].line; /* Relocated (JBV) */
+#endif
 
    }
 
@@ -2168,7 +2224,8 @@ bwb_exitfor( l )
    /* set the next line in the exec stack */
 
    next_line->position = 0;
-   bwb_setexec( next_line, 0, EXEC_NORM );
+   /* bwb_setexec( next_line, 0, EXEC_NORM ); */  /* WRONG (JBV) */
+   bwb_setexec( next_line, 0, CURTASK excs[ CURTASK exsc ].code ); /* JBV */
 
    return next_line;
 
@@ -2405,5 +2462,3 @@ var_setnval( v, i )
 
    }
 
-
-
\ No newline at end of file
diff --git a/bwb_dio.c b/bwb_dio.c
index 6f4759f..5da4dce 100644
--- a/bwb_dio.c
+++ b/bwb_dio.c
@@ -23,6 +23,11 @@
 
 ***************************************************************/
 
+/*---------------------------------------------------------------*/
+/* NOTE: Modifications marked "JBV" were made by Jon B. Volkoff, */
+/* 11/1995 (eidetics@cerf.net).                                  */
+/*---------------------------------------------------------------*/
+
 #include <stdio.h>
 
 #include "bwbasic.h"
@@ -352,7 +357,7 @@ bwb_open( l )
       if ( e->type == STRING )
          {
 #if PROG_ERRORS
-         bwb_error( "String where number was expected for record length" );
+         bwb_error( "String where number was expected for dev number" );
 #else
          bwb_error( err_syntax );
 #endif
@@ -490,6 +495,9 @@ bwb_open( l )
 
    /* assign values to device table */
 
+   /* Random mode has a default record length (JBV) */
+   if (mode == DEVMODE_RANDOM && rlen == -1) rlen = 128;
+
    dev_table[ req_devnumber ].mode = mode;
    dev_table[ req_devnumber ].cfp = fp;
    dev_table[ req_devnumber ].reclen = rlen;
@@ -497,11 +505,17 @@ bwb_open( l )
    dev_table[ req_devnumber ].loc = 0;
    strcpy( dev_table[ req_devnumber ].filename, devname );
 
+   /* File length finding routine, added by JBV */
+   fseek( dev_table[ req_devnumber ].cfp, 0, SEEK_END );
+   dev_table[ req_devnumber ].lof = ftell( dev_table[ req_devnumber ].cfp );
+   fseek( dev_table[ req_devnumber ].cfp, 0, SEEK_SET );
+
    /* allocate a character buffer for random access */
 
    if (( mode == DEVMODE_RANDOM ) && ( previous_buffer != TRUE ))
       {
-      if ( ( dev_table[ req_devnumber ].buffer = calloc( rlen + 1, 1 )) == NULL )
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( dev_table[ req_devnumber ].buffer = CALLOC( rlen + 1, 1, "bwb_open" )) == NULL )
 	 {
 #if PROG_ERRORS
 	 bwb_error( "in bwb_open(): failed to find memory for device buffer" );
@@ -552,14 +566,21 @@ bwb_close( l )
    {
    struct exp_ese *e;
    char atbuf[ MAXSTRINGSIZE + 1 ];
+   int blanket_close; /* JBV */
+   register int n; /* JBV */
+
+   blanket_close = -1; /* JBV */
+   req_devnumber = 0; /* JBV */
 
    /* loop to get device numbers to close */
 
    do
       {
 
+      if ( l->buffer[ l->position ] == ',' && blanket_close == 0)
+         ++( l->position); /* JBV */
       adv_ws( l->buffer, &( l->position ) );
-      if ( l->buffer[ l->position ] =='#' )
+      if ( l->buffer[ l->position ] == '#')
          {
          ++( l->position );
          }
@@ -579,7 +600,31 @@ bwb_close( l )
          return bwb_zline( l );
          }
 
-      req_devnumber = (int) exp_getnval( e );
+      /*-------------------------------------------------------------*/
+      /* Added the following section for blanket close feature (JBV) */
+      /*-------------------------------------------------------------*/
+      if (blanket_close == -1)
+      if (strlen(atbuf) != 0) blanket_close = 0;
+      else blanket_close = 1;
+
+      if (blanket_close == 0) req_devnumber = (int) exp_getnval( e );
+      else
+      {
+          ++req_devnumber;
+
+          /* Find the next device in use */
+          for (n = req_devnumber; n < DEF_DEVICES; ++n)
+          {
+              req_devnumber = -1;
+              if (( dev_table[ n ].mode != DEVMODE_CLOSED ) &&
+                 ( dev_table[ n ].mode != DEVMODE_AVAILABLE ) )
+              {
+                  req_devnumber = n;
+                  break;
+              }
+          }
+          if (req_devnumber == -1) break; /* Skidoo if no more to close */
+      }
 
 #if INTENSIVE_DEBUG
       sprintf( bwb_ebuf, "in bwb_close(): requested device number <%d>",
@@ -633,13 +678,20 @@ bwb_close( l )
 
       dev_table[ req_devnumber ].mode = DEVMODE_CLOSED;
 
+      /* Revised to FREE pass-thru call by JBV */
+      if ( dev_table[ req_devnumber ].buffer != NULL )
+      {
+          FREE( dev_table[ req_devnumber ].buffer, "bwb_close" ); /* JBV */
+          dev_table[ req_devnumber ].buffer = NULL; /* JBV */
+      }
+
       /* eat up any remaining whitespace */
 
       adv_ws( l->buffer, &( l->position ) );
 
       }
 
-   while ( l->buffer[ l->position ] == ',' );
+   while ( l->buffer[ l->position ] == ',' || blanket_close == 1); /* JBV */
 
    /* return next line number in sequence */
 
@@ -680,7 +732,9 @@ bwb_chdir( l )
    if ( init == FALSE )
       {
       init = TRUE;
-      if ( ( atbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( atbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "bwb_chdir" )) == NULL )
          {
 #if PROG_ERRORS
 	 bwb_error( "in bwb_chdir(): failed to find memory for atbuf" );
@@ -758,7 +812,9 @@ bwb_rmdir( l )
    if ( init == FALSE )
       {
       init = TRUE;
-      if ( ( atbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( atbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "bwb_rmdir" )) == NULL )
          {
 #if PROG_ERRORS
 	 bwb_error( "in rmdir(): failed to find memory for atbuf" );
@@ -835,7 +891,9 @@ bwb_mkdir( l )
    if ( init == FALSE )
       {
       init = TRUE;
-      if ( ( atbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( atbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "bwb_mkdir" )) == NULL )
          {
 #if PROG_ERRORS
 	 bwb_error( "in bwb_mkdir(): failed to find memory for atbuf" );
@@ -916,7 +974,9 @@ bwb_kill( l )
    if ( init == FALSE )
       {
       init = TRUE;
-      if ( ( atbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( atbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "bwb_kill" )) == NULL )
          {
 #if PROG_ERRORS
 	 bwb_error( "in bwb_kill(): failed to find memory for atbuf" );
@@ -998,7 +1058,9 @@ bwb_name( l )
    if ( init == FALSE )
       {
       init = TRUE;
-      if ( ( atbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( atbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "bwb_name" )) == NULL )
          {
 #if PROG_ERRORS
 	 bwb_error( "in bwb_name(): failed to find memory for atbuf" );
@@ -1006,7 +1068,8 @@ bwb_name( l )
 	 bwb_error( err_getmem );
 #endif
 	 }
-      if ( ( btbuf = calloc( MAXSTRINGSIZE + 1, sizeof( char ) )) == NULL )
+      /* Revised to CALLOC pass-thru call by JBV */
+      if ( ( btbuf = CALLOC( MAXSTRINGSIZE + 1, sizeof( char ), "bwb_name" )) == NULL )
 	 {
 #if PROG_ERRORS
 	 bwb_error( "in bwb_name(): failed to find memory for btbuf" );
@@ -1269,7 +1332,9 @@ bwb_field( l )
 #if DONTDOTHIS
       if ( b->sbuffer != NULL )
 	 {
-	 free( b->sbuffer );
+         /* Revised to FREE pass-thru call by JBV */
+	 FREE( b->sbuffer, "bwb_field" );
+	 b->sbuffer = NULL; /* JBV */
 	 }
 #endif
 
@@ -1281,7 +1346,7 @@ bwb_field( l )
 
 #if INTENSIVE_DEBUG
       sprintf( bwb_ebuf, "in bwb_field(): buffer <%lXh> var <%s> buffer <%lXh>",
-         (long) dev_table[ dev_number ].buffer, v->name, (long) b->buffer );
+         (long) dev_table[ dev_number ].buffer, v->name, (long) b->sbuffer );
       bwb_debug( bwb_ebuf );
 #endif
 
@@ -1466,7 +1531,7 @@ dio_lrset( l, rset )
 
 #if INTENSIVE_DEBUG
    sprintf( bwb_ebuf, "in dio_lrset(): startpos <%d> buffer <%lX>",
-      startpos, (long) d->buffer );
+      startpos, (long) d->sbuffer );
    bwb_debug( bwb_ebuf );
 #endif
 
@@ -1510,6 +1575,7 @@ bwb_get( l )
    register int i;
    struct exp_ese *e;
    char atbuf[ MAXSTRINGSIZE + 1 ];
+   long offset; /* JBV */
 
    /* first read device number */
 
@@ -1583,9 +1649,10 @@ bwb_get( l )
 
    /* wind the c file up to the proper point */
 
-   if ( fseek( dev_table[ dev_number ].cfp,
-      (long) (( rec_number - 1 ) * dev_table[ dev_number ].reclen ),
-      SEEK_SET ) != 0 )
+   /* Added by JBV */
+   offset = (long) (( rec_number - 1 ) * dev_table[ dev_number ].reclen);
+
+   if ( fseek( dev_table[ dev_number ].cfp, offset, SEEK_SET ) != 0 )
       {
 #if PROG_ERRORS
       sprintf( bwb_ebuf, "in bwb_get(): fseek() failed, rec number <%d> offset <%ld>",
@@ -1599,6 +1666,7 @@ bwb_get( l )
 
    /* read the requested bytes into the buffer */
 
+   dev_table[ dev_number ].loc = offset; /* Slight bug fix (JBV) */
    for ( i = 0; i < dev_table[ dev_number ].reclen; ++i )
       {
       dev_table[ dev_number ].buffer[ i ] =
@@ -1639,6 +1707,7 @@ bwb_put( l )
    register int i;
    struct exp_ese *e;
    char atbuf[ MAXSTRINGSIZE + 1 ];
+   long offset; /* JBV */
 
    /* first read device number */
 
@@ -1649,7 +1718,23 @@ bwb_put( l )
       }
 
    adv_element( l->buffer, &( l->position ), atbuf );
-   dev_number = atoi( atbuf );
+/*   dev_number = atoi( atbuf ); */  /* Not quite right (JBV) */
+
+   /* Added by JBV */
+   pos = 0;
+   e = bwb_exp( atbuf, FALSE, &pos );
+
+   if ( e->type != NUMBER )
+      {
+#if PROG_ERRORS
+      bwb_error( "in bwb_put(): Number was expected for device number" );
+#else
+      bwb_error( err_syntax );
+#endif
+      return bwb_zline( l );
+      }
+
+   dev_number = (int) exp_getnval( e );
 
 #if INTENSIVE_DEBUG
    sprintf( bwb_ebuf, "in bwb_put(): device <%d>", dev_number );
@@ -1709,9 +1794,10 @@ bwb_put( l )
 
    /* wind the c file up to the proper point */
 
-   if ( fseek( dev_table[ dev_number ].cfp,
-      (long) (( rec_number - 1 ) * dev_table[ dev_number ].reclen ),
-      SEEK_SET ) != 0 )
+   /* Added by JBV */
+   offset = (long) (( rec_number - 1 ) * dev_table[ dev_number ].reclen);
+
+   if ( fseek( dev_table[ dev_number ].cfp, offset, SEEK_SET ) != 0 )
       {
 #if PROG_ERRORS
       sprintf( bwb_ebuf, "in bwb_get(): fseek() failed, rec number <%d> offset <%ld>",
@@ -1732,6 +1818,7 @@ bwb_put( l )
 
    /* write the requested bytes to the file */
 
+   dev_table[ dev_number ].loc = offset; /* Slight bug fix (JBV) */
    for ( i = 0; i < dev_table[ dev_number ].reclen; ++i )
       {
       fputc( dev_table[ dev_number ].buffer[ i ],
@@ -1804,4 +1891,3 @@ dio_flush( dev_number )
 #endif				/* COMMON_CMDS */
 
 
-
\ No newline at end of file
